
#include <stdio.h>
#include <malloc.h>

#define max(x,y) (((x)>(y))?(x):(y))
#define min(x,y) (((x)<(y))?(x):(y))

int N;
float **X, *XX;

void initX()
{
	int i,j;
	for( i=0 ; i<=4*N ; i++ )
		for( j=0 ; j<=2*N ; j++ )
			X[i][j] = 1.;
}
/*********************************************************/
/*void calcul_jk_k_i()
 *{
 *	float Y=0.;
 *	int i,j,k;
 *
 *	for( i=1 ; i<=N ; i++ )
 *		for( j=i+1 ; j<=i+N ; j++ )
 *			for( k=1 ; k<=2*N ; k++ )
 *				Y += X[j][i] + X[k][j+k];
 *
 *	printf( "%f\n", Y );
 *}
 */
/*********************************************************/
void calcul_orig() /* _k_jk_i */
{
	float Y=0.;
	int i,j,k;

	for( i=1 ; i<=N ; i++ )
		for( j=1 ; j<=N ; j++ )
			for( k=1 ; k<=2*N ; k++ )
				Y += X[j+k+1][k] + X[i+j+k][i];

	printf( "%f\n", Y );
}
/*********************************************************/
void calcul_temp() /* _k_jk_i */
{
	float Y=0.;
	int i,j,k;

	for( i=1 ; i<=2*N ; i++ )
		for( j=i+1 ; j<=i+N ; j++ )
			for( k=1 ; k<=N ; k++ )
				Y += X[j+1][i] + X[j+k][k];

	printf( "%f\n", Y );
}
/*********************************************************/
void calcul_temp_decoup() /* _k_jk_i */
{
	float Y=0.;
	int i,j,k;

	for( i=1 ; i<=N ; i++ )
	{	for( j=i+1 ; j<=1+N ; j++ )
			for( k=1 ; k<=N ; k++ )
				Y += X[j+1][i] + X[j+k][k];
		for( j=N+2 ; j<=i+N ; j++ )
			for( k=1 ; k<=N ; k++ )
				Y += X[j+1][i] + X[j+k][k];
	}
	for( i=N+1 ; i<=2*N ; i++ )
		for( j=i+1 ; j<=i+N ; j++ )
			for( k=1 ; k<=N ; k++ )
				Y += X[j+1][i] + X[j+k][k];

	printf( "%f\n", Y );
}
/*********************************************************/
void calcul_temp_et_spac() /* _k_jk_i */
{
	float Y=0.;
	int i,j,k;
	int a,b,c,d;

	a=1; b=1;
	for( i=1 ; i<=N ; i++ )
	{
		for( j=i+1 ; j<=N+1 ; j++ )
		{
			for( k=1 ; k<=N ; k++ )
			{
				Y += XX[b] + XX[a];
				a++;
			}
			b += N;
		}
		a += N*i - N*N;
		c=N*N+1;
		for( j=N+2 ; j<=N+i ; j++ )
		{
			for( k=1 ; k<=N ; k++ )
			{
				Y += XX[b] + XX[c];
				c += 1;
			}
			b += N;
		}
		b += - N*N + 1;
	}

	d=(2*N-1)*N + 1; c = N*N + 1;
	for( i=N+1 ; i<=2*N ; i++ )
	{
		for( j=i+1 ; j<=N+i ; j++ )
		{
			for( k=1 ; k<=N ; k++ )
			{
				Y += XX[d] + XX[c];
				c ++;
			}
			d ++;
		}
		c += (1-N)*N;
	}

	printf( "%f\n", Y );
}
/*********************************************************/
void calcul_temp_et_spac_C() /* _k_jk_i */
{
	float Y=0.;
	int i,j,k;
	int a,b,c;

	a=1; b=1;
	for( i=1 ; i<=N ; i++ )
	{
		for( j=i+1 ; j<=N+1 ; j++ )
		{
			for( k=1 ; k<=N ; k++ )
			{
				Y += XX[b] + XX[a];
				a++;
			}
			b += N;
		}
		a += N*i - N*N;
		c=N*N+1;
		for( j=N+2 ; j<=N+i ; j++ )
		{
			for( k=1 ; k<=N ; k++ )
			{
				Y += XX[b] + XX[c];
				c += 1;
			}
			b += N;
		}
		b += - N*N + 1;
	}
	printf( "%f\n", Y );
}

void calcul_temp_et_spac_E() /* _k_jk_i */
{
	float Y=0.;
	int i,j,k;
	int c,d;

	d=(2*N-1)*N + 1; c = N*N + 1;
	for( i=N+1 ; i<=2*N ; i++ )
	{
		for( j=i+1 ; j<=N+i ; j++ )
		{
			for( k=1 ; k<=N ; k++ )
			{
				Y += XX[d] + XX[c];
				c ++;
			}
			d ++;
		}
		c += (1-N)*N;
	}

	printf( "%f\n", Y );
}
/*********************************************************/

/*********************************************************/

void init()
{
	int i;
	/* ----------------------------------------------------------- */
	if( !(X = (float **) malloc( sizeof(float *) * (4*N+1) )) )
	{
		printf( "malloc failed\n" );
		exit( -1 );
	}
	if( !(XX = (float *)malloc( sizeof(float) * (4*N+1) * (2*N+1) )) )
	{
		printf( "malloc failed\n" );
		exit( -1 );
	}
	for( i=0 ; i<=4*N ; i++ )
		X[i] = XX+(2*N+1)*i;
}

/*********************************************************/
int main()
{

	printf( " N = ");
	scanf( " %d", &N );

	init();

	initX();
	calcul_orig();
	initX();
	calcul_temp();
	initX();
	calcul_temp_decoup();
	initX();
	calcul_temp_et_spac();


	return( 0 );

}
